#include "stdafx.h"
#include "Event.h"
#include "functions.h"


Event::Event()
{
}


Event::~Event()
{
}

bool Event::operator<(const Event& rhs) { // "strre enn" betyr "senere"
	if (half != 16 && rhs.half == 16) {
		return false;
	}
	else if (half == 16 && rhs.half != 16) {
		return true;
	}
	else if (half != 16 && rhs.half != 16 && half < rhs.half) {
		return true;
	}
	else if (half != 16 && rhs.half != 16 && half > rhs.half) {
		return false;
	}
	else {
		if (min < rhs.min) {
			return true;
		}
		else if (min > rhs.min) {
			return false;
		}
		else {
			if (sec < rhs.sec) {
				//double s = sec;
				//double s2 = s+2;
				//if (typeId == 5 && rhs.typeId == 13 && (rhs.sec>s)) {
				//	return false;
				//}
				//else {
					return true;
				//}
			}
			else if (sec == rhs.sec) {
				if (rhs.typeId == 5) {
					return true;
				}
				else if (typeId == 5){
					return false;
				}
				else if (rhs.typeId == 0) {
					return false;
				}
				else if (typeId == 0) {
					return true;
                }
                else if (rhs.markovId == 130) {
                    return false;
                }
                else if (markovId == 130) {
                    return true;
                }
                else if (markovId == 100 && rhs.markovId == 13){
                    return false;
                }
                else if (markovId == 13 && rhs.markovId == 100){
                    return true;
                }
				else {
                    return false;
				}
			}
			else{
				return false;
			}
		}
	}
}

bool Event::operator==(const Event& rhs) {
	if (id == rhs.id) {
		return true;
	}
	else {
		return false;
	}
}

bool Event::operator!=(const Event& rhs) {
	if (id == rhs.id) {
		return false;
	}
	else {
		return true;
	}
}

void Event::findEnd(double& x, double& y) {
	for (int i = 0;i < qId.size();i++) {
		if (qId[i] == 140) {
			x = values[i];
		}
		else if (qId[i] == 141) {
			y = values[i];
		}
	}
}

void Event::setEnd() {
	double x, y;
	findEnd(x, y);
	endX = x;
	endY = y;
}

void Event::calculateLengthAndAngle() {
	double a,b,a2, b2, c2, l2;
	a2 = pow(100 - this->x, 2) + pow(55.3 - this->y, 2);
	b2 = pow(100 - this->x, 2) + pow(44.7 - this->y, 2);
	c2 = pow(10.6, 2);
	l2 = pow(100 - this->x, 2) + pow(50 - this->y, 2);
	a = sqrt(a2);
	b = sqrt(b2);
	this->lengthToGoal = sqrt(l2);
	this->angleToGoal = acos((a2 + b2 - c2) / (2 * a*b));
}

bool Event::qualExist(int id) {
	bool ut = false;
	for (unsigned int i = 0;i < qId.size();i++) {
		if (qId[i] == id) {
			ut = true;
			break;
		}
	}
	return ut;
}

double Event::findQualVal(int id) {
	double ut = -1;
	for (unsigned int i = 0;i < this->qId.size();i++) {
		if (qId[i] == id) {
			ut = values[i];
			break;
		}
	}
	return ut;
}

bool Event::isCross() {
	bool ut = false;
	if (typeId == 1 && this->qualExist(2) && !this->qualExist(5) && !this->qualExist(6)) {
		ut = true;
	}
	return ut;
}

bool Event::isCorner() {
	bool ut = false;
	if (typeId == 1 && this->qualExist(6)) {
		ut = true;
	}
	return ut;
}

bool Event::isPass() {
	bool ut = false;
	if (typeId == 1 && !this->qualExist(2) && !this->qualExist(5) && !this->qualExist(6)) {
		ut = true;
	}
	return ut;
}

bool Event::isSuccPass() {
	bool ut = false;
	if (typeId == 1 && !this->qualExist(2) && !this->qualExist(5) && !this->qualExist(6) && this->outcome == 1) {
		ut = true;
	}
	return ut;
}

bool Event::isLongPass() {
	bool ut = false;
	if (this->isPass() && this->qualExist(1)) {
		ut = true;
	}
	return ut;
}

bool Event::isForwardPass() {
	bool ut = false;
	double endX, endY;
	this->findEnd(endX, endY);
	if (this->isPass() && endX<this->x) {
		ut = true;
	}
	return ut;
}

bool Event::isAllPasses() {
	bool ut = false;
	if (typeId == 1 && !this->qualExist(5) && !this->qualExist(6)) {
		ut = true;
	}
	return ut;
}

bool Event::isShotOnTarget() {
	bool ut = false;
	if ((this->typeId == 15 || this->typeId == 16) && !this->qualExist(28)) {
		ut = true;
	}
	return ut;
}

bool Event::isYellow() {
	bool ut = false;
	if (this->typeId == 17 && (this->qualExist(31) || this->qualExist(32))) {
		ut = true;
	}
	return ut;
}

bool Event::isTackle() {
	bool ut = false;
	if (this->typeId == 7 || this->typeId == 45) {
		ut = true;
	}
	return ut;
}

bool Event::isWonTackle() {
	bool ut = false;
	if (this->isTackle() && this->outcome == 1) {
		ut = true;
	}
	return ut;
}

bool Event::isFastBreak() {
	bool ut = false;
	if (this->qualExist(23)) {
		ut = true;
	}
	return ut;
}

bool Event::isBallWin() {
	bool ut = false;
	if ((typeId == 7 || typeId == 12 || typeId == 49 || typeId == 8 || typeId == 74) && outcome == 1) {
		ut = true;
	}
	return ut;
}

bool Event::isRedundant2() {
	bool ut = false;
	if (typeId == 18 || typeId == 19 || typeId == 24 || typeId == 27 || typeId == 28 || typeId == 30 || typeId == 32 || typeId == 40 || typeId == 41 || typeId == 42 || typeId == 43 || typeId == 45 ||typeId == 51 || typeId == 52 || typeId == 53 || typeId == 54 || typeId == 55 || typeId == 56 || typeId == 58 || typeId == 59 || typeId == 65 || typeId == 68 || typeId == 70) {
		ut = true;
	}
	return ut;
}


// DISSE ER FOR SKUDD
void Event::findRoughFieldZone() {
	if (this->x >= 0 && this->x < 50 && this->y >= 0 && this->y <= 100) {
		this->fieldRoughZone = 0;
	}
	else if (this->x >= 50 && this->x < 60 && this->y >= 75 && this->y <= 100) {
		this->fieldRoughZone = 1;
	}
	else if (this->x >= 60 && this->x < 70 && this->y >= 75 && this->y <= 100){
		this->fieldRoughZone = 2;
	}
	else if (this->x >= 70 && this->x < 80 && this->y >= 75 && this->y <= 100) {
		this->fieldRoughZone = 3;
	}
	else if (this->x >= 80 && this->x < 90 && this->y >= 75 && this->y <= 100) {
		this->fieldRoughZone = 4;
	}
	else if (this->x >= 90 && this->x < 100 && this->y >= 75 && this->y <= 100) {
		this->fieldRoughZone = 5;
	}
	else if (this->x >= 50 && this->x < 60 && this->y >= 50 && this->y < 75) {
		this->fieldRoughZone = 6;
	}
	else if (this->x >= 60 && this->x < 70 && this->y >= 50 && this->y < 75) {
		this->fieldRoughZone = 7;
	}
	else if (this->x >= 70 && this->x < 80 && this->y >= 50 && this->y < 75) {
		this->fieldRoughZone = 8;
	}
	else if (this->x >= 80 && this->x < 90 && this->y >= 50 && this->y < 75) {
		this->fieldRoughZone = 9;
	}
	else if (this->x >= 90 && this->x < 100 && this->y >= 50 && this->y < 75) {
		this->fieldRoughZone = 10;
	}
	else if (this->x >= 50 && this->x < 60 && this->y >= 25 && this->y < 50) {
		this->fieldRoughZone = 11;
	}
	else if (this->x >= 60 && this->x < 70 && this->y >= 25 && this->y < 50) {
		this->fieldRoughZone = 12;
	}
	else if (this->x >= 70 && this->x < 80 && this->y >= 25 && this->y < 50) {
		this->fieldRoughZone = 13;
	}
	else if (this->x >= 80 && this->x < 90 && this->y >= 25 && this->y < 50) {
		this->fieldRoughZone = 14;
	}
	else if (this->x >= 90 && this->x < 100 && this->y >= 25 && this->y < 50) {
		this->fieldRoughZone = 15;
	}
	else if (this->x >= 50 && this->x < 60 && this->y >= 0 && this->y < 25) {
		this->fieldRoughZone = 16;
	}
	else if (this->x >= 60 && this->x < 70 && this->y >= 0 && this->y < 25) {
		this->fieldRoughZone = 17;
	}
	else if (this->x >= 70 && this->x < 80 && this->y >= 0 && this->y < 25) {
		this->fieldRoughZone = 18;
	}
	else if (this->x >= 80 && this->x < 90 && this->y >= 0 && this->y < 25) {
		this->fieldRoughZone = 19;
	}
	else if (this->x >= 90 && this->x < 100 && this->y >= 0 && this->y < 25) {
		this->fieldRoughZone = 20;
	}
	// sjekke om det var en heading: if (HENDELSE.qualExist(15) == true)
} //  // for skudd

void Event::findFieldZone() { //deler 16-meteren inn i 2x2 meters felt
	if (this->x >= 97.9 && this->x <= 100 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 1;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 25.4 && this->y < 29.5){
		this->fieldZone = 2;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 3;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 4;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 5;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 6;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 7;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 8;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 9;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 10;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 11;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 12;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 13;
	}
	else if (this->x >= 97.9 && this->x <= 100 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 14;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 15;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 16;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 17;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 18;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 19;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 20;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 21;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 22;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 23;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 24;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 25;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 26;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 27;
	}
	else if (this->x >= 95.7 && this->x < 97.9 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 28;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 29;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 30;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 31;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 31;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 33;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 34;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 35;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 36;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 37;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 38;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 39;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 40;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 41;
	}
	else if (this->x >= 93.6 && this->x < 95.7 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 42;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 43;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 44;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 45;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 46;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 47;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 48;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 49;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 50;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 51;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 52;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 53;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 54;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 55;
	}
	else if (this->x >= 91.5 && this->x < 93.6 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 56;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 57;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 58;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 59;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 60;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 61;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 62;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 63;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 64;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 65;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 66;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 67;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 68;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 69;
	}
	else if (this->x >= 89.4 && this->x < 91.5 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 70;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 71;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 72;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 73;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 74;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 75;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 76;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 77;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 78;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 79;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 80;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 81;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 82;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 83;
	}
	else if (this->x >= 87.2 && this->x < 89.4 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 84;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 85;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 86;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 87;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 88;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 89;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 90;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 91;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 92;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 93;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 94;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 95;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 96;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 97;
	}
	else if (this->x >= 85.1 && this->x < 87.2 && this->y >= 74.8 && this->y < 78.9) {
		this->fieldZone = 98;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 21.3 && this->y < 25.4) {
		this->fieldZone = 99;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 25.4 && this->y < 29.5) {
		this->fieldZone = 100;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 29.5 && this->y < 33.6) {
		this->fieldZone = 101;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 33.6 && this->y < 37.8) {
		this->fieldZone = 102;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 37.8 && this->y < 41.9) {
		this->fieldZone = 103;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 41.9 && this->y < 46.0) {
		this->fieldZone = 104;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 46.0 && this->y < 50.1) {
		this->fieldZone = 105;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 50.1 && this->y < 54.2) {
		this->fieldZone = 106;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 54.2 && this->y < 58.3) {
		this->fieldZone = 107;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 58.3 && this->y < 62.4) {
		this->fieldZone = 108;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 62.4 && this->y < 66.6) {
		this->fieldZone = 109;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 66.6 && this->y < 70.7) {
		this->fieldZone = 110;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 70.7 && this->y < 74.8) {
		this->fieldZone = 111;
	}
	else if (this->x >= 83.0 && this->x < 85.1 && this->y >= 74.8 && this->y <= 78.9) {
		this->fieldZone = 112;
	}
	else if (this->x < 83.0 || this->y > 78.9 || this->y < 21.1)
		this->fieldZone = 113;
} // for skudd

// TIL MARKOV

void Event::setTimePeriod() {
	if (half == 1) {
		if (min < 23) {
			markovPeriod = 1;
		}
		else {
			markovPeriod = 2;
		}
	}
	else if (half == 2) {
		if (min < 68) {
			markovPeriod = 3;
		}
		else {
			markovPeriod = 4;
		}
	}
	else {
		markovPeriod = 0;
	}
}

bool Event::isStartEvent() {
	bool ut = false;
	if ( (typeId == 1 && (qualExist(279) || qualExist(107) || qualExist(124) /*|| qualExist(123) || qualExist(198) || qualExist(199) || qualExist(240) */) ) || typeId == 32) {
		ut = true;
	}
	return ut;
}

bool Event::isShot() {
	bool ut = false;
	if ((this->typeId == 13 || this->typeId == 14 || this->typeId == 15 || this->typeId == 16) && !this->qualExist(28)) {
		ut = true;
	}
	return ut;
}

bool Event::isBreakEvent(){
    bool ut = false;
    if (typeId == 16 || (typeId == 5 && outcome == 1) || typeId == 13 || (typeId == 17 && (qualExist(32) || qualExist(33) )) || (typeId == 30 && (half == 1 || half == 2) && home == 1)){
        ut = true;
    }
    return ut;
}

bool Event::isRedudant(){
    bool ut = false;
    if ( (typeId == 4 || typeId == 5|| typeId == 6 || typeId == 44) && outcome == 0){
        ut = true;
    }
    return ut;
}

bool Event::isFreeKick(){
    bool ut = false;
    if (typeId == 1 && qualExist(5)){
        ut = true;
    }
    return ut;
}

bool Event::isGKEvent(){
    bool ut = false;
    if (typeId == 10 || typeId == 11|| typeId == 41 || typeId == 52 || typeId == 53 || typeId == 54 || typeId == 58 || typeId == 59){
        ut = true;
    }
    return ut;
}
