#pragma once
#include "stdafx.h"



class StateClass{
public:
    StateClass();
    int type;
    int outcome;
    int period;
    int status;
    int manpower;
    int zone;
    int zoneEnd;
    int goal;
    int home;
    int stateId;
    int bigState;
    double lengthZone;
    ~StateClass();
    
    map<StateClass, double> count;
    map<int, double> c;
    map<StateClass, double> prob;
    double occ;
    
    map<int, double> actionCountH;
    map<int, double> actionCountA;
    map<int, double> actionCount;
    map<int, double> actionValue;
    map<int, double> actionValueH;
    map<int, double> actionValueA;
    map<int, map<int, double>> actionStateH;
    map<int, map<int, double>> actionStateA;
    map<int, map<int, double>> actionState;
    int policyH;
    int policyA;
    int policy;
    double value;
    double valueH;
    double valueA;
    double vmax;
    double reward;
    double rewardH;
    double rewardA;
    
    bool operator==(const StateClass& rhs);
    friend bool operator <(const StateClass& lhs, const StateClass& rhs);

};


